﻿-- Author      : Nogarder
-- Create Date : 2013/4/29 17:02:05
local next=next

NPA_Options.SettingTranslator={}
--
NPA_Options.SettingTranslator.ExportProfile=function(profilename,entryname)
	local indexpart={string.split("\\",entryname)}
	local profile
	if(profilename=="TheCurrentProfile")then
		profile=NPA_Setting
	else
		profile=NPA_Profile[profilename]
	end
	--
	local indexlength=table.getn(indexpart)
	for i=2,indexlength do
		profile=profile[tonumber(indexpart[i])] or profile[indexpart[i]]
	end
	--
	--build index
	local indextable={}
	local output={}
	local offset=0
	local checklist={
		[1]={
			Name=indexpart[indexlength],
			Pointer=profile,
			Parent=nil
		}
	}
	while(next(checklist))do
		for index,data in pairs(checklist)do
			local name=data.Name
			local position=1
			if(data.Parent)then
				for i=1,table.getn(output)do
					if(output[i]==data.Parent)then
						position=i+1
						break
					end
				end
			end

			if(type(data.Pointer)=="table")then
				local str=name.."={"
				table.insert(output,position,"}")
				table.insert(output,position,str)
				for dindex,ddata in pairs(data.Pointer)do
					table.insert(checklist,{Name=dindex,Pointer=ddata,Parent=str})
				end
			elseif(type(data.Pointer)=="boolean")then
				if(value==true)then
					table.insert(output,position,name.."=1,")
				else
					table.insert(output,position,name.."=0,")
				end
			else
				table.insert(output,position,name.."="..data.Pointer..",")
			end
			checklist[index]=nil
		end
	end

	local retstring=""
	for i=1,table.getn(output)do
		retstring=retstring..output[i]
	end

	for i=indexlength-1,2,-1 do
		retstring=indexpart[i].."={"..retstring.."}"
	end

	return retstring
end
--
NPA_Options.SettingTranslator.InportProfile=function(settingstring)
	local settinglist={string.split("&",settingstring)}
	local settings={}
	for i=2,table.getn(settinglist)do
		local setting={}
		local currentname=""
		local currentvalue=""
		local previoustable={}
		local thestring=settinglist[i]
		local state=0 -- 0= get name, 1=get value
		for i=1,string.len(thestring)do
			local char=string.sub(thestring,i,i)
			if(char==",")then
				state=0
				setting[currentname]=currentvalue
				currentname=""
				currentvalue=""
			elseif(char=="=")then
				state=1
				currentvalue=""
			elseif(char=="{")then
				state=0
				setting[currentname]={}
				previoustable[setting[currentname]]=setting
				setting=setting[currentname]
				--
				currentname=""
			elseif(char=="}")then
				setting=previoustable[setting]
			elseif(state==0)then
				currentname=currentname..char
			elseif(state==1)then
				currentvalue=currentvalue..char
			end
		end

		settings[i-1]=setting
	end
	return settings
end